\ trilaterasjon provisorisk xy ----------------------------
-1 [IF]
\ Relevante sikt for skjring, maks 3 sikt
\ 1-3 er relevante siktnr, 0 er antal sikt
\ 4 INTEGER ARRAY SKJSIKT{
\ : .skjs   cr 4 0 do   skjsikt{ i } ?   loop ;
: skjsiktantal   skjsikt{ 0 } @ ;
\ : 0skjsikt   4 0 do  0 skjsikt{ i } !   loop ;

\ skjring av to sirklar (0, l), tredje sirkel (2) for eintydig lysing
\ Lysing i skj0





: endekoo? ( pnr snr - flagg )  \ sikt med minst eitt kjent endepkt?
   nip DUP ( snr snr )
   SFRANR{ SWAP } @   har-koo?  ( snr flagg )
   SWAP STILNR{ SWAP } @  har-koo?   OR ;

: tre? ( - flagg )              \ har funne tre sikt?
   skjsiktantal 2 > ;
[THEN]

: til/fra? ( pnr snr - flagg )  \ sikt mot eller fra punktet?
   DUP SFRANR{ SWAP } @ SWAP STILNR{ SWAP } @  ( pnr fn tn ) 
   ROT DUP ( fn tn pnr pnr )
   ROT ( fn pnr pnr tn )
   = ( fn pnr flagg1 )
   ROT ROT = OR ;

: endepkt ( 1/2/3 - pnr )       \ ta fram trilaterasjonsdata
   skjsikt{ SWAP } @  ( snr ) DUP  SFRANR{ SWAP } @   DUP   
   har-koo? IF  nip EXIT  THEN
   DROP STILNR{ SWAP } @ ;

: lengde ( 1/2/3 -  L )         \ ta fram trilaterasjonsdata
   skjsikt{ SWAP } @ ( snr ) LS{ over } @ VV{ rot } @ horisontrer ;


: relevant? ( pnr snr - flagg ) \ relevant for punktet?
      2DUP til/fra?   ( flagg )
      ROT ROT 2DUP nip HarLengdeobs?   ( flagg )
      ROT ROT endekoo?   ( flagg ) \ minst ein kjent ende
      AND AND ( flagg ) ;

\ hent 2 eller 3 sett trilat-obs
:  obs ( 3 - pnr L pnr L pnr L )   ( 2 - pnr L pnr L )
   1 + 1 DO
      i endepkt ( pnr )
	  @x'y'     ( x y )
      i lengde  ( x y L )
   LOOP ;
: Trilater1 ( x y R0 x y Rl x y R2 - flagg )
    trilati ( x y ) AND ;


: trilat3 ( - flagg )
   skjsiktantal 2 > IF
      3 obs   trilater1
   ELSE
      FALSE
   THEN ;                   \ fr 3 obs, autmatisk eintydig

DEFER koord-rekn

: koord-rekn3 ( - flagg )  \ 3 buer
   trilat3  IF TRUE EXIT ELSE
   FALSE THEN ;

: oppdater-pkt ( pnr -- )   \ koo funne, lagre
    DUP ginr   >R   ( )
    skj0 2@   ( x y )
    R@  !x'y'  
	1 opphav{ R> } ! ;   \ 1 = provisorisk xy

: relevant! ( snr - )       \ lagre snr for relevant sikt
   1 skjsikt{ 0 } +!            \ tell
   skjsiktantal skjsikt{ SWAP } ! ; \ lagre snr i skjsikt 1,2 eller 3

: ubrukt?  ( snr -- f ) \ dupliserte sikt i inndata
	LS{ swap } @ ( L )
	dup 1 lengde = ( brukt som L1 )
	swap 2 lengde =     ( brukt som L2 )
	OR 0= ;

: sikt-skaff ( pnr - )      \ finn relevante sikt
   0skjsikt       \ nullstill skjsikt
   AlleSikt DO
      DUP i ( pnr snr )
     swap over relevant?  ( snr  f )  nip \ swap ubrukt?  AND
      IF I relevant! THEN
      tre? IF LEAVE THEN    \ meir enn tre er uinterssant
   LOOP DROP ;

\ Trilaterasjon krev minst 2 sikt. M endrast for andre metodar!!!
: mange-nok? ( - flagg )    \ nok relevante sikt?
   skjsiktantal 2 > ; \ krev 3 sikt

: skjering? ( pnr - flagg )
   DROP koord-rekn ;

: underbestemt? ( pnr - flagg )
   sikt-skaff mange-nok? 0= ;

: provis ( pnr -- ) 
   DUP har-koo? IF drop EXIT THEN
   DUP underbestemt? IF drop EXIT THEN
   DUP skjering? 0= IF drop EXIT THEN
   oppdater-pkt ;

: provisrunde1
   AllePkt DO
      I provis
	  ntalgml @ ntal2 @   <  IF LEAVE THEN \ eitt nypkt
   LOOP ;

: buebuebue    ( -- )
	['] koord-rekn3 IS koord-rekn      \ finn eintydige skj
	provisrunde1 ( pktprov ) ;
