\ Normallikning--------------------------------------------------------------------------

\ Viktig: Gitt pkt har ikkje element, og er tildelt negativt elementnr
\ Obs utan orientering ( td lengder) er tildelt negativt elementnr

: Lengdelikning ( snr -- )
	LSvekt{ over } @ Pvekt !  DannLengdelikning
	FyllNormallikningane ;

: Retningslikning ( snr -- )
	HVvekt{ over } @ Pvekt !  DannRetningslikning
	FyllNormallikningane ;
	
: Feillikningar ( snr -- ) \                    cr dup .
	dup siktdata  ( snr )
	LS{ over } @ ( snr L ) IF  dup Lengdelikning   THEN
	dup HarRetningsobs?    IF  RetningsLikning  ELSE  drop  THEN ; 

: Normallikn1 ( - ) \ rå, alt i ei matrise, N1
	6 0NL \ antall koeff + konstantledd, x1 y1 x2 y2 o f
	AlleSikt DO
		I Feillikningar
	LOOP 
	N1{{ etal @ DUP }} @   sumpvvi ! ; 

: korreksjonar ( - )	        \ Ein omgang
   Normallikn1			 \ rå normallikningar
   FinnSvar1 ;				\ kopier til A og løys

: korriger1 ( pnr - ) \ korreksjonar i X -> XY{  
  DUP >R
  elementnr2 ( ex ey )
   X{ SWAP } @ ( ex dy )
   SWAP X{ SWAP } @ SWAP ( dx dy )   \ korreksjonar
	XY{ R@ } 2@  k+                  \ gamle koo + korr
	XY{ R> } 2! ;                    \ nye koo

: korrigerxy ( - )   \ alle nypkt
    AllePkt DO
       NYPNR{ I } @ IF I korriger1 THEN
    LOOP ;

: korriger1or ( ornr -- ) \ X{ inneheld or-korreksjon i trig-einingar )
	DUP ntal2 @ 2*  + ( elementnr ) X{ swap } @ ( ornr korreksjon )
	OE{ ROT } +! ;        \ OE{ inneheld or-vinklar i iu-einingar )

: korrigerOr
	#orienteringar @ 1 > IF
		#orienteringar @ 0 DO  I korriger1or  LOOP 
	ELSE
		0 korriger1or  \ unngå loop med 1 runde
	THEN ;

: korrigerxyo ( -- )
	korrigerxy   #orienteringar @  IF  korrigerOr  THEN ;

: Finreknxy ( -- f )
	9 1 DO
		korreksjonar
		CR CR ." Iterasjon nr " I . ." :" ItResultat
		Grovfeil?    IF  CR ." Grovfeil"  0   UNLOOP EXIT   THEN
		Overflyt?    IF  CR ." Overflyt"  0   UNLOOP EXIT   THEN
		FKSAuke?     IF  ForkastSiste    -1   UNLOOP EXIT   THEN
		FKSlik?      IF                  -1   UNLOOP EXIT   THEN
		Stabilt?     IF  korrigerxyo     -1   UNLOOP EXIT   THEN
		korrigerxyo
		sumpvvi @  SumvvForrige !
    LOOP -1 ;

: etalxy ( -- ) ntal2 @ 2*  #orienteringar @ +  etal ! ; \ antal ukjente
\ -----------------------------------------------------------------

: Betra?  ( -- f )                     \ flagg vellukka
	etalxy NLiknplass   etal @ +gauss  \ lag plass
	stort SumvvForrige !		       \ set sumpvv stor
	CR ." Krymping " krymping ?
	Finreknxy ( f ) CR ;



